1. 程式人生 > >[LeetCode] Find Anagram Mappings 尋找異構對映

[LeetCode] Find Anagram Mappings 尋找異構對映

Given two lists and B, and B is an anagram of AB is an anagram of A means B is made by randomizing the order of the elements in A.

We want to find an index mapping P, from A to B. A mapping P[i] = j means the ith element in A appears in B at index j.

These lists A and B may contain duplicates. If there are multiple answers, output any of them.

For example, given

A = [12, 28, 46, 32, 50]
B = [50, 12, 32, 46, 28]

We should return

[1, 4, 3, 2, 0]

as P[0] = 1 because the 0th element of A appears at B[1], and P[1] = 4 because the 1st element of Aappears at B[4], and so on.

Note:

  1. A, B have equal lengths in range [1, 100].
  2. A[i], B[i]
     are integers in range [0, 10^5].

這道題給了我們兩個陣列A和B,說是A和B中的數字都相同,但是順序不同,有點類似錯位詞的感覺。讓我們找出陣列A中的每個數字在陣列B中的位置。這道題沒有太大的難度,用個HashMap建立陣列B中的每個數字和其位置之間的對映,然後遍歷陣列A,在HashMap中查詢每個數字的位置即可,參見程式碼如下:

class Solution {
public:
    vector<int> anagramMappings(vector<int>& A, vector<int>& B) {
        vector
<int> res; unordered_map<int, int> m; for (int i = 0; i < B.size(); ++i) m[B[i]] = i; for (int num : A) res.push_back(m[num]); return res; } };

類似題目: